
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/sysinfo.h>
#include <string.h>
#include <unistd.h>

#define DISPLAYUNIT (1024 * 1024)

void sleeping(int seconds)
{
    printf("sleeping %d seconds\n", seconds);
    sleep(seconds);
}

int main(int argc, char argv[])
{
    struct sysinfo sys_info;
    memset(&sys_info, 0, sizeof(sys_info));
    if(!sysinfo(&sys_info)) {
	printf(
	    "unit size:\t%12u byte(s)\n#\nfreeram:\t%12lu\nbufferram:\t%12lu\n----\nSum:\t\t%12lu\n",
	    sys_info.mem_unit,
	    sys_info.freeram * sys_info.mem_unit / DISPLAYUNIT,
	    sys_info.bufferram * sys_info.mem_unit / DISPLAYUNIT,
	    (sys_info.freeram + sys_info.bufferram) * sys_info.mem_unit / DISPLAYUNIT
	    );

	unsigned long some_memory = (sys_info.freeram + sys_info.bufferram) * (unsigned long)sys_info.mem_unit;
	printf("#\ntrying to allocate %lu\n", some_memory / DISPLAYUNIT);
	void *allocated = malloc((size_t)some_memory);
	sleeping(5);
	if(allocated) {
	    printf("allocate twice as much\n");
	    free(allocated);
	    allocated = malloc((size_t)(some_memory + some_memory));
	    sleeping(5);
	    if(allocated) {
		printf("memset allocated memory to 0\n");
		memset(allocated, 0, (size_t)(some_memory + some_memory));
		sleeping(5);
		free(allocated);
		printf("memory freed\n");
	    } else {
		printf("larger memory allocation failed\n");
	    }
	} else {
	    printf("memory allocation failed\n");
	}
    } else {
	printf("error: sysinfo not available\n");
	exit(-1);
    }
    exit(0);
}
